import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { Search } from '../../dto';
import { AbstractBodyDto } from '../../dto/body/abtract-body.dto';
import { SchemaValidator } from '../../helper/validator/schema-validator.helper';
import { RequestSchema } from '../../interface/input-schema.interface';
import { AbstractEntityLoader } from '../../loader/abstract-entity.loader';
export declare abstract class AbstractController<Collection, GetResponse, SearchParams extends Search, BodyDto extends AbstractBodyDto> extends AbstractEntityLoader {
    readonly entity: string;
    readonly fieldSchemaData?: FieldSchema[];
    readonly entitySchemaData?: EntitySchema[];
    readonly errorService?: ErrorService;
    readonly translationService?: GetTranslationService;
    requestSchema: RequestSchema;
    schemaValidator: SchemaValidator;
    constructor(entity: string, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], errorService?: ErrorService, translationService?: GetTranslationService);
    isMethodAllowed(method: string): void;
}
