/// <reference types="mongoose/types/aggregate" />
/// <reference types="mongoose/types/callback" />
/// <reference types="mongoose/types/collection" />
/// <reference types="mongoose/types/connection" />
/// <reference types="mongoose/types/cursor" />
/// <reference types="mongoose/types/document" />
/// <reference types="mongoose/types/error" />
/// <reference types="mongoose/types/expressions" />
/// <reference types="mongoose/types/helpers" />
/// <reference types="mongoose/types/middlewares" />
/// <reference types="mongoose/types/indexes" />
/// <reference types="mongoose/types/models" />
/// <reference types="mongoose/types/mongooseoptions" />
/// <reference types="mongoose/types/pipelinestage" />
/// <reference types="mongoose/types/populate" />
/// <reference types="mongoose/types/query" />
/// <reference types="mongoose/types/schemaoptions" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/types" />
/// <reference types="mongoose/types/utility" />
/// <reference types="mongoose/types/validation" />
/// <reference types="mongoose/types/virtuals" />
/// <reference types="mongoose/types/inferschematype" />
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { ObjectId } from 'mongoose';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { ClonyManyBodyDto, ClonyOneBodyDto } from '../../dto/body/clone-body.dto';
import { CloneManyResponse, CloneOneResponse } from '../../dto/response/clone.response';
import { GenericCreateService } from '../../service/abstract/generic-create.service';
export declare function GenericCreateController<Collection, GetResponse, SearchParams, BodyDto>({ entity, authGuard, interceptor, }: {
    entity: string;
    authGuard: any;
    interceptor: any;
}): {
    new (createService?: GenericCreateService<Collection, GetResponse, BodyDto>, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], errorService?: ErrorService, translationService?: GetTranslationService): {
        readonly createService?: GenericCreateService<Collection, GetResponse, BodyDto>;
        readonly fieldSchemaData?: FieldSchema[];
        readonly entitySchemaData?: EntitySchema[];
        readonly errorService?: ErrorService;
        readonly translationService?: GetTranslationService;
        create(body: BodyDto): Promise<{
            _id: ObjectId;
        }>;
        cloneById(id: string, body: ClonyOneBodyDto): Promise<CloneOneResponse>;
        cloneManyByIds(body: ClonyManyBodyDto): Promise<CloneManyResponse>;
        requestSchema: import("../..").RequestSchema;
        schemaValidator: import("../..").SchemaValidator;
        readonly entity: string;
        isMethodAllowed(method: string): void;
        readonly logger: import("@nestjs/common").Logger;
        entitySchema: EntitySchema;
        entityLabels: string[];
        fieldSchemaDb: FieldSchema[];
    };
};
