"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericCreateController = void 0;
const common_1 = require("@nestjs/common");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const abstract_controller_1 = require("../abstract/abstract.controller");
const nestjs_microservices_core_1 = require("@devseeder/nestjs-microservices-core");
const generic_create_service_1 = require("../../service/abstract/generic-create.service");
const allKey = 'CREATE';
function GenericCreateController({ entity, authGuard, interceptor, }) {
    let GenericCreateControllerHost = class GenericCreateControllerHost extends abstract_controller_1.AbstractController {
        constructor(createService, fieldSchemaData, entitySchemaData, errorService, translationService) {
            super(entity, fieldSchemaData, entitySchemaData, errorService, translationService);
            this.createService = createService;
            this.fieldSchemaData = fieldSchemaData;
            this.entitySchemaData = entitySchemaData;
            this.errorService = errorService;
            this.translationService = translationService;
        }
        create(body) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('create');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'create', body, this.fieldSchemaData);
                return this.createService.create(body);
            });
        }
        cloneById(id, body) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('cloneById');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'cloneOne', body, this.fieldSchemaData);
                const response = yield this.createService.cloneByIds([id], body.cloneRelations, body.replaceBody);
                return response[0];
            });
        }
        cloneManyByIds(body) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('cloneManyByIds');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'cloneMany', body, this.fieldSchemaData);
                return this.createService.cloneByIds(body._ids, body.cloneRelations, body.replaceBody);
            });
        }
    };
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'CREATE' }),
        (0, common_1.Post)(`/`),
        __param(0, (0, common_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], GenericCreateControllerHost.prototype, "create", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'CLONE_ONE' }),
        (0, common_1.Post)(`/clone/:id`),
        __param(0, (0, common_1.Param)('id')),
        __param(1, (0, common_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, Object]),
        __metadata("design:returntype", Promise)
    ], GenericCreateControllerHost.prototype, "cloneById", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'CLONE_MANY' }),
        (0, common_1.Post)(`/clone`),
        __param(0, (0, common_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], GenericCreateControllerHost.prototype, "cloneManyByIds", null);
    GenericCreateControllerHost = __decorate([
        (0, common_1.UseInterceptors)(interceptor),
        (0, common_1.Controller)(entity.toLowerCase()),
        __param(0, (0, common_1.Inject)(`GENERIC_CREATE_SERVICE_${entity}`)),
        __param(1, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.FIELD_SCHEMA_DB)),
        __param(2, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.ENTITY_SCHEMA_DB)),
        __metadata("design:paramtypes", [generic_create_service_1.GenericCreateService, Array, Array, nestjs_microservices_schemas_1.ErrorService,
            nestjs_microservices_schemas_1.GetTranslationService])
    ], GenericCreateControllerHost);
    Object.defineProperty(GenericCreateControllerHost, 'name', {
        value: `Generic${entity.capitalizeFirstLetter()}CreateController`,
    });
    return GenericCreateControllerHost;
}
exports.GenericCreateController = GenericCreateController;
