import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { CountResponse, PaginatedResponse } from '../../dto/response/paginated.response';
import { GroupByResponse } from '../../dto/response/groupby/group-by.response';
import { FormSchemaResponse } from '../../interface/field-schema.interface';
import { GenericGetService } from '../../service/abstract/generic-get.service';
export declare function GenericGetController<Collection, GetResponse, SearchParams, BodyDto>({ entity, authGuard, interceptor, }: {
    entity: string;
    authGuard: any;
    interceptor: any;
}): {
    new (getService?: GenericGetService<Collection, GetResponse, SearchParams>, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], errorService?: ErrorService, translationService?: GetTranslationService): {
        readonly getService?: GenericGetService<Collection, GetResponse, SearchParams>;
        readonly fieldSchemaData?: FieldSchema[];
        readonly entitySchemaData?: EntitySchema[];
        readonly errorService?: ErrorService;
        readonly translationService?: GetTranslationService;
        getById(id: string): Promise<GetResponse>;
        searchBy(params: SearchParams, searchId: string): Promise<PaginatedResponse<GetResponse>>;
        searchAll(params: SearchParams): Promise<PaginatedResponse<GetResponse>>;
        count(params: SearchParams): Promise<CountResponse>;
        getForm(): Promise<FormSchemaResponse>;
        groupBy(relation: string, params: SearchParams): Promise<GroupByResponse[]>;
        requestSchema: import("../..").RequestSchema;
        schemaValidator: import("../..").SchemaValidator;
        readonly entity: string;
        isMethodAllowed(method: string): void;
        readonly logger: import("@nestjs/common").Logger;
        entitySchema: EntitySchema;
        entityLabels: string[];
        fieldSchemaDb: FieldSchema[];
    };
};
