"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericGetController = void 0;
const common_1 = require("@nestjs/common");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const abstract_controller_1 = require("../abstract/abstract.controller");
const nestjs_microservices_core_1 = require("@devseeder/nestjs-microservices-core");
const error_keys_enum_1 = require("../../enum/error-keys.enum");
const generic_get_service_1 = require("../../service/abstract/generic-get.service");
const allKey = 'GET';
function GenericGetController({ entity, authGuard, interceptor, }) {
    let GenericGetControllerHost = class GenericGetControllerHost extends abstract_controller_1.AbstractController {
        constructor(getService, fieldSchemaData, entitySchemaData, errorService, translationService) {
            super(entity, fieldSchemaData, entitySchemaData, errorService, translationService);
            this.getService = getService;
            this.fieldSchemaData = fieldSchemaData;
            this.entitySchemaData = entitySchemaData;
            this.errorService = errorService;
            this.translationService = translationService;
        }
        getById(id) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.getService.getById(id, true);
            });
        }
        searchBy(params, searchId) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('searchBy');
                if (params[this.entitySchema.searchKey] !== undefined)
                    this.errorService.throwError(error_keys_enum_1.ErrorKeys.NOT_ALLOWED, {
                        key: this.entitySchema.searchKey,
                    });
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'search', params, this.fieldSchemaData, true);
                if (this.entitySchema.searchKey)
                    params[this.entitySchema.searchKey] = searchId;
                return this.getService.search(params);
            });
        }
        searchAll(params) {
            return __awaiter(this, void 0, void 0, function* () {
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'search', params, this.fieldSchemaData, true);
                return this.getService.search(params);
            });
        }
        count(params) {
            return __awaiter(this, void 0, void 0, function* () {
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'count', params, this.fieldSchemaData, true);
                return this.getService.count(params);
            });
        }
        getForm() {
            return this.getService.getForm();
        }
        groupBy(relation, params) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('groupby');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'groupBy', params, this.fieldSchemaData, true);
                return this.getService.groupBy(relation, params);
            });
        }
    };
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'GET_BY_ID' }),
        (0, common_1.Get)(`/:id`),
        __param(0, (0, common_1.Param)('id')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String]),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "getById", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'SEARCH_BY_ID' }),
        (0, common_1.Get)(`/search/:searchId`),
        __param(0, (0, common_1.Query)()),
        __param(1, (0, common_1.Param)('searchId')),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, String]),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "searchBy", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'SEARCH_ALL' }),
        (0, common_1.Get)(`/`),
        __param(0, (0, common_1.Query)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "searchAll", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'COUNT' }),
        (0, common_1.Get)(`/meta/count`),
        __param(0, (0, common_1.Query)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "count", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'GET_FORM' }),
        (0, common_1.Get)(`/form/fields`),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "getForm", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'GROUP_BY' }),
        (0, common_1.Get)(`/groupby/:relation`),
        __param(0, (0, common_1.Param)('relation')),
        __param(1, (0, common_1.Query)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, Object]),
        __metadata("design:returntype", Promise)
    ], GenericGetControllerHost.prototype, "groupBy", null);
    GenericGetControllerHost = __decorate([
        (0, common_1.UseInterceptors)(interceptor),
        (0, common_1.Controller)(entity.toLowerCase()),
        __param(0, (0, common_1.Inject)(`GENERIC_GET_SERVICE_${entity}`)),
        __param(1, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.FIELD_SCHEMA_DB)),
        __param(2, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.ENTITY_SCHEMA_DB)),
        __metadata("design:paramtypes", [generic_get_service_1.GenericGetService, Array, Array, nestjs_microservices_schemas_1.ErrorService,
            nestjs_microservices_schemas_1.GetTranslationService])
    ], GenericGetControllerHost);
    Object.defineProperty(GenericGetControllerHost, 'name', {
        value: `Generic${entity.capitalizeFirstLetter()}GetController`,
    });
    return GenericGetControllerHost;
}
exports.GenericGetController = GenericGetController;
