import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { ActivationQueryParams } from '../../dto/query/activation-query-params.dto';
import { GenericUpdateService } from '../../service/abstract/generic-update.service';
export declare function GenericUpdateController<Collection, GetResponse, SearchParams, BodyDto>({ entity, authGuard, interceptor, }: {
    entity: string;
    authGuard: any;
    interceptor: any;
}): {
    new (updateService?: GenericUpdateService<Collection, GetResponse, BodyDto, SearchParams>, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], errorService?: ErrorService, translationService?: GetTranslationService): {
        readonly updateService?: GenericUpdateService<Collection, GetResponse, BodyDto, SearchParams>;
        readonly fieldSchemaData?: FieldSchema[];
        readonly entitySchemaData?: EntitySchema[];
        readonly errorService?: ErrorService;
        readonly translationService?: GetTranslationService;
        inactivate(id: string, queryParams: ActivationQueryParams): Promise<void>;
        activate(id: string, queryParams: ActivationQueryParams): Promise<void>;
        updateById(id: string, body: BodyDto): Promise<void>;
        updateBy(params: SearchParams, body: BodyDto): Promise<void>;
        requestSchema: import("../..").RequestSchema;
        schemaValidator: import("../..").SchemaValidator;
        readonly entity: string;
        isMethodAllowed(method: string): void;
        readonly logger: import("@nestjs/common").Logger;
        entitySchema: EntitySchema;
        entityLabels: string[];
        fieldSchemaDb: FieldSchema[];
    };
};
