"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericUpdateController = void 0;
const common_1 = require("@nestjs/common");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const abstract_controller_1 = require("../abstract/abstract.controller");
const nestjs_microservices_core_1 = require("@devseeder/nestjs-microservices-core");
const activation_query_params_dto_1 = require("../../dto/query/activation-query-params.dto");
const generic_update_service_1 = require("../../service/abstract/generic-update.service");
const allKey = 'UPDATE';
function GenericUpdateController({ entity, authGuard, interceptor, }) {
    let GenericUpdateControllerHost = class GenericUpdateControllerHost extends abstract_controller_1.AbstractController {
        constructor(updateService, fieldSchemaData, entitySchemaData, errorService, translationService) {
            super(entity, fieldSchemaData, entitySchemaData, errorService, translationService);
            this.updateService = updateService;
            this.fieldSchemaData = fieldSchemaData;
            this.entitySchemaData = entitySchemaData;
            this.errorService = errorService;
            this.translationService = translationService;
        }
        inactivate(id, queryParams) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('inactivate');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'activation', queryParams);
                yield this.updateService.activation(id, false, queryParams.cascadeRelations);
            });
        }
        activate(id, queryParams) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('activate');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'activation', queryParams);
                yield this.updateService.activation(id, true, queryParams.cascadeRelations);
            });
        }
        updateById(id, body) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('updateById');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'update', body, this.fieldSchemaData);
                yield this.updateService.updateById(id, body);
            });
        }
        updateBy(params, body) {
            return __awaiter(this, void 0, void 0, function* () {
                this.isMethodAllowed('updateBy');
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'search', params, [], true);
                yield this.schemaValidator.validateRequestSchema(this.requestSchema, 'update', body, this.fieldSchemaData);
                yield this.updateService.updateBy(params, body);
            });
        }
    };
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'INACTIVATE' }),
        (0, common_1.Patch)(`inactivate/:id`),
        __param(0, (0, common_1.Param)('id')),
        __param(1, (0, common_1.Query)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, activation_query_params_dto_1.ActivationQueryParams]),
        __metadata("design:returntype", Promise)
    ], GenericUpdateControllerHost.prototype, "inactivate", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'ACTIVATE' }),
        (0, common_1.Patch)(`activate/:id`),
        __param(0, (0, common_1.Param)('id')),
        __param(1, (0, common_1.Query)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, activation_query_params_dto_1.ActivationQueryParams]),
        __metadata("design:returntype", Promise)
    ], GenericUpdateControllerHost.prototype, "activate", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'UPDATE_BY_ID' }),
        (0, common_1.Patch)(`/:id`),
        __param(0, (0, common_1.Param)('id')),
        __param(1, (0, common_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [String, Object]),
        __metadata("design:returntype", Promise)
    ], GenericUpdateControllerHost.prototype, "updateById", null);
    __decorate([
        (0, common_1.UseGuards)(authGuard),
        (0, nestjs_microservices_core_1.MetaScope)({ entity, accessKey: 'UPDATE_MANY' }),
        (0, common_1.Patch)(`/`),
        __param(0, (0, common_1.Query)()),
        __param(1, (0, common_1.Body)()),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Promise)
    ], GenericUpdateControllerHost.prototype, "updateBy", null);
    GenericUpdateControllerHost = __decorate([
        (0, common_1.UseInterceptors)(interceptor),
        (0, common_1.Controller)(entity.toLowerCase()),
        __param(0, (0, common_1.Inject)(`GENERIC_UPDATE_SERVICE_${entity}`)),
        __param(1, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.FIELD_SCHEMA_DB)),
        __param(2, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.ENTITY_SCHEMA_DB)),
        __metadata("design:paramtypes", [generic_update_service_1.GenericUpdateService, Array, Array, nestjs_microservices_schemas_1.ErrorService,
            nestjs_microservices_schemas_1.GetTranslationService])
    ], GenericUpdateControllerHost);
    Object.defineProperty(GenericUpdateControllerHost, 'name', {
        value: `Generic${entity.capitalizeFirstLetter()}UpdateController`,
    });
    return GenericUpdateControllerHost;
}
exports.GenericUpdateController = GenericUpdateController;
