import { AnySchema, ObjectSchema, Root, SchemaMap } from 'joi';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema, SearchEgineOperators } from '@devseeder/nestjs-microservices-schemas';
import { InputSchema, RequestSchema } from '../../interface/input-schema.interface';
export declare class FieldSchemaBuilder {
    protected readonly errorService: ErrorService;
    private readonly entitySchemaData;
    private schemaValidator;
    private entitySchema;
    constructor(errorService: ErrorService, translationService: GetTranslationService, entity: string, entitySchemaData: EntitySchema[]);
    buildRequestSchemas(entityFields: FieldSchema[], fieldSchemaData: FieldSchema[]): RequestSchema;
    buildSchemas(fieldSchema: FieldSchema[]): InputSchema;
    cleanSchema(fieldSchema: FieldSchema[]): FieldSchema[];
    buildSearchSchema(fieldSchema: FieldSchema[], commons?: SchemaMap): ObjectSchema;
    buildUpdateSchema(fieldSchema: FieldSchema[]): ObjectSchema;
    buildCloneSchema(fieldSchema: FieldSchema[], cloneSchema: SchemaMap): ObjectSchema;
    buildObjectUpdate(fieldSchema: FieldSchema[]): SchemaMap;
    buildCreateSchema(fieldSchema: FieldSchema[]): ObjectSchema;
    getType(Joi: Root, schema: FieldSchema, search?: boolean, array?: boolean, schemasDb?: any[]): AnySchema;
    buildArrayField(Joi: Root, schema: FieldSchema, search?: boolean, schemasDb?: FieldSchema[]): AnySchema;
    buildObjectFieldSchema(Joi: Root, schema: FieldSchema, search?: boolean, schemasDb?: FieldSchema[]): SchemaMap | null;
    buildSearchEngine(schema: FieldSchema, objectSchema: SchemaMap): boolean;
    getFormFilterCondition(page: string, field: FieldSchema): boolean;
    static checkUndefinedValue(value: any, schema: FieldSchema, itemResponse: any, operator: SearchEgineOperators): boolean;
}
