import { ObjectSchema } from 'joi';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { InputSchema, RequestSchema } from '../../interface/input-schema.interface';
export declare class SchemaValidator {
    private readonly errorService;
    private readonly translationService;
    private readonly entitySchema;
    private readonly entitySchemaData?;
    private logger;
    constructor(errorService: ErrorService, translationService: GetTranslationService, entitySchema: EntitySchema, entitySchemaData?: EntitySchema[]);
    validateRequestSchema(schema: RequestSchema, requestMethod: string, obj: any, fieldSchemasDb?: FieldSchema[], encapsulate?: boolean): Promise<void>;
    validateFamilySchema(schemaRelation: InputSchema, requestMethod: string, obj: object, fieldSchemasDb: FieldSchema[], encapsulate?: boolean): Promise<void>;
    validateSchema(schema: ObjectSchema, obj: object, fieldSchemasDb?: FieldSchema[], encapsulate?: boolean): Promise<void>;
    validateSingleSchema(schema: ObjectSchema, obj: object, fieldSchemasDb?: FieldSchema[]): Promise<void>;
    validateEnum(values: any[]): any;
    executeValidationField(schema: FieldSchema, item: object): Promise<void>;
    private printSchemaError;
    static removeUndefined<FilteredObject>(obj: object): FilteredObject;
}
