import { Provider } from '@nestjs/common';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { ModuleRef } from '@nestjs/core';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { CustomProvider } from '../dto';
import { GenericRepository } from '../mongoose';
import { ModelEntityTokens } from './model-entity-token.injector';
export declare class DependencyInjectorService {
    private moduleRef;
    private entitySchemaData;
    private fieldSchemaData;
    private translationService;
    private errorService;
    protected readonly request: Request;
    protected readonly scopeKey: string;
    protected readonly modelTokens: ModelEntityTokens;
    private entitySchema;
    private parentFields;
    private serviceCache;
    constructor(moduleRef: ModuleRef, entitySchemaData: EntitySchema[], fieldSchemaData: FieldSchema[], translationService: GetTranslationService, errorService: ErrorService, request: Request, scopeKey: string, modelTokens: ModelEntityTokens);
    setSchema(entity: string): void;
    static injectRepository<Collection>(entity: string, modelName: string, customProvider?: CustomProvider): Provider;
    injectService<Collection, T>(entity: string, repository: GenericRepository<any>, genericClass: any, providerKey: string, customProvider?: CustomProvider, children?: boolean): Promise<T>;
    private injectParents;
    private injectChildren;
    private injectFamily;
    injectGetService<Collection>(entity: string, repository: GenericRepository<any>, customProvider?: CustomProvider, children?: boolean): Promise<unknown>;
    injectUpdateService<Collection>(entity: string, repository: GenericRepository<any>, customProvider?: CustomProvider, children?: boolean): Promise<unknown>;
    injectCreateService<Collection>(entity: string, repository: GenericRepository<any>, customProvider?: CustomProvider, children?: boolean): Promise<unknown>;
    private getInstance;
}
