"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DependencyInjectorService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const core_1 = require("@nestjs/core");
const app_constants_1 = require("../app.constants");
const mongoose_2 = require("../mongoose");
const service_1 = require("../service");
let DependencyInjectorService = class DependencyInjectorService {
    constructor(moduleRef, entitySchemaData, fieldSchemaData, translationService, errorService, request, scopeKey, modelTokens) {
        this.moduleRef = moduleRef;
        this.entitySchemaData = entitySchemaData;
        this.fieldSchemaData = fieldSchemaData;
        this.translationService = translationService;
        this.errorService = errorService;
        this.request = request;
        this.scopeKey = scopeKey;
        this.modelTokens = modelTokens;
        this.serviceCache = {};
    }
    setSchema(entity) {
        this.entitySchema = this.entitySchemaData.filter((ent) => ent.entity === entity)[0];
        this.parentFields = this.fieldSchemaData
            .filter((field) => field.entity === entity ||
            field.entity === nestjs_microservices_schemas_1.GLOBAL_ENTITY ||
            (this.entitySchema.extendedEntities &&
                this.entitySchema.extendedEntities.includes(field.entity)))
            .filter((field) => field.type === 'externalId');
    }
    static injectRepository(entity, modelName, customProvider) {
        return {
            provide: `GENERIC_REPOSITORY_${entity}`,
            useFactory: (model) => {
                let classService = (mongoose_2.GenericRepository);
                if (customProvider && customProvider.repository)
                    classService = customProvider.repository;
                return createInstance(classService, model);
            },
            inject: [(0, mongoose_1.getModelToken)(modelName)],
        };
    }
    injectService(entity, repository, genericClass, providerKey, customProvider, children = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceKey = `${providerKey}${entity.capitalizeFirstLetter()}Service`;
            this.setSchema(entity);
            const { args, classService } = this.getInstance(entity, repository, genericClass, providerKey, customProvider);
            const service = createInstance(classService, ...args);
            yield this.injectParents(service, 'get', serviceKey);
            if (children)
                yield this.injectChildren(service, 'get', serviceKey);
            if (providerKey !== 'get' && children)
                yield this.injectChildren(service, providerKey, serviceKey);
            this.serviceCache[serviceKey] = service;
            return service;
        });
    }
    injectParents(service, providerKey, originalServiceKey) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                for (var _d = true, _e = __asyncValues(this.parentFields), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const parent = _c;
                    yield this.injectFamily(service, providerKey, parent.externalRelation.service, originalServiceKey);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_1) throw e_1.error; }
            }
        });
    }
    injectChildren(service, providerKey, originalServiceKey) {
        var _a, e_2, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                for (var _d = true, _e = __asyncValues(this.entitySchema.subRelations), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const sub = _c;
                    yield this.injectFamily(service, providerKey, sub.service, originalServiceKey, true);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        });
    }
    injectFamily(service, providerKey, relation, originalServiceKey, children = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const serviceKey = `${providerKey}${relation.capitalizeFirstLetter()}Service`;
            const relModel = this.moduleRef.get((0, mongoose_1.getModelToken)(this.modelTokens[relation].modelName), {
                strict: false,
            });
            const relRepository = new mongoose_2.GenericRepository(relModel);
            const relProvider = yield this[`inject${providerKey.capitalizeFirstLetter()}Service`](relation, relRepository, {}, false);
            if (children)
                relProvider[originalServiceKey] = service;
            service[serviceKey] = relProvider;
        });
    }
    injectGetService(entity, repository, customProvider, children = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.injectService(entity, repository, (service_1.GenericGetService), 'get', customProvider, children);
        });
    }
    injectUpdateService(entity, repository, customProvider, children = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.injectService(entity, repository, (service_1.GenericUpdateService), 'update', customProvider, children);
        });
    }
    injectCreateService(entity, repository, customProvider, children = true) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.injectService(entity, repository, (service_1.GenericCreateService), 'create', customProvider, children);
        });
    }
    getInstance(entity, repository, genericClass, providerKey, customProvider) {
        let classService = genericClass;
        const defaultArgs = [
            this.fieldSchemaData,
            this.entitySchemaData,
            this.translationService,
            this.errorService,
            this.request,
            this.scopeKey,
        ];
        let args = [repository, entity, ...defaultArgs];
        if (customProvider && customProvider[providerKey]) {
            classService = customProvider[providerKey].className;
            args = [repository, ...defaultArgs];
            const injectArgs = customProvider[providerKey].injectArgs;
            if (injectArgs && injectArgs.length) {
                for (const arg of injectArgs) {
                    args.push(this.moduleRef.get(arg, { strict: false }));
                }
            }
        }
        return { args, classService };
    }
};
exports.DependencyInjectorService = DependencyInjectorService;
exports.DependencyInjectorService = DependencyInjectorService = __decorate([
    (0, common_1.Injectable)({ scope: common_1.Scope.REQUEST }),
    __param(1, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.ERROR_SCHEMA_DB)),
    __param(2, (0, common_1.Inject)(nestjs_microservices_schemas_1.SchemaDependecyTokens.FIELD_SCHEMA_DB)),
    __param(5, (0, common_1.Inject)(core_1.REQUEST)),
    __param(6, (0, common_1.Inject)(app_constants_1.DependencyInjectorToken.SCOPE_KEY)),
    __metadata("design:paramtypes", [core_1.ModuleRef, Array, Array, nestjs_microservices_schemas_1.GetTranslationService,
        nestjs_microservices_schemas_1.ErrorService,
        Request, String, Object])
], DependencyInjectorService);
function createInstance(classReference, ...args) {
    return new classReference(...args);
}
