"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractEntityLoader = void 0;
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const common_1 = require("@nestjs/common");
class AbstractEntityLoader {
    constructor(entity, fieldSchemaData, entitySchemaData) {
        this.entity = entity;
        this.fieldSchemaData = fieldSchemaData;
        this.entitySchemaData = entitySchemaData;
        this.logger = new common_1.Logger(AbstractEntityLoader.name);
        const filterEntity = entitySchemaData.filter((ent) => ent.entity === entity);
        if (!filterEntity.length)
            throw new common_1.NotAcceptableException(`No entity found for ${entity}`);
        this.entitySchema = filterEntity[0];
        this.entityLabels = [
            this.entitySchema.entity,
            ...(this.entitySchema.extendedEntities || []),
        ];
        if (!this.fieldSchemaData || !this.fieldSchemaData.length)
            return;
        this.fieldSchemaDb = this.fieldSchemaData.filter((schema) => this.entityLabels.includes(schema.entity) ||
            schema.entity === nestjs_microservices_schemas_1.GLOBAL_ENTITY ||
            schema.entity === this.entitySchema.entity);
    }
}
exports.AbstractEntityLoader = AbstractEntityLoader;
