import { DynamicModule } from '@nestjs/common';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { ModuleRef } from '@nestjs/core';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { CustomProvider } from '../dto';
import { GenericRepository } from '../mongoose';
import { ModelEntityTokens } from '../injector/model-entity-token.injector';
export interface GenericModuleOptions {
    modelName: string;
    entity: string;
    configuration: any;
    customProvider?: CustomProvider;
    authGuard: any;
    interceptor: any;
    modelTokens: ModelEntityTokens;
}
export declare class GenericModule {
    static forFeature(options: GenericModuleOptions): DynamicModule;
    static loadServiceProvider<Collection>(entity: string, providerKey: string, modelTokens: ModelEntityTokens, customProvider?: CustomProvider): {
        provide: string;
        useFactory: (moduleRef: ModuleRef, repository: GenericRepository<Collection>, fieldSchemaData: FieldSchema[], entitySchemaData: EntitySchema[], translationService: GetTranslationService, errorService: ErrorService, request: Request, scopeKey: string) => Promise<any>;
        inject: (string | typeof ModuleRef | typeof GetTranslationService | typeof ErrorService)[];
    };
}
