"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericRepository = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("mongoose");
const mongoose_repository_1 = require("./mongoose.repository");
let GenericRepository = class GenericRepository extends mongoose_repository_1.MongooseRepository {
    constructor(model) {
        super(model);
    }
    groupBy(searchParams, entityRel, fkField, sumField = '', array = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const aggGroup = { count: { $sum: 1 } };
            if (sumField) {
                aggGroup[`total${sumField.capitalizeFirstLetter()}`] = {
                    $sum: `$${sumField}`,
                };
                aggGroup[`avg${sumField.capitalizeFirstLetter()}`] = {
                    $avg: `$${sumField}`,
                };
            }
            const aggParam = [
                {
                    $match: searchParams,
                },
                ...this.returnLookupGroupBy(entityRel, fkField, array),
                {
                    $group: Object.assign({ _id: `$${entityRel}Objects._id`, name: { $first: `$${entityRel}Objects.name` } }, aggGroup),
                },
            ];
            this.logger.log(`Aggregate: ${JSON.stringify(aggParam)}`);
            return this.model.aggregate(aggParam);
        });
    }
    returnLookupGroupBy(entityRel, fkField, array = false) {
        if (array)
            return [
                {
                    $unwind: `$${entityRel}`,
                },
                {
                    $lookup: {
                        from: entityRel,
                        let: { pids: { $split: [`$${fkField}`, ','] } },
                        pipeline: [
                            {
                                $match: {
                                    $expr: {
                                        $in: [
                                            { $toObjectId: '$_id' },
                                            {
                                                $map: {
                                                    input: '$$pids',
                                                    as: 'pid',
                                                    in: { $toObjectId: '$$pid' },
                                                },
                                            },
                                        ],
                                    },
                                },
                            },
                        ],
                        as: `${entityRel}Objects`,
                    },
                },
            ];
        return [
            {
                $lookup: {
                    from: entityRel,
                    let: { stringValue: { $toObjectId: `$${fkField}` } },
                    pipeline: [
                        {
                            $match: {
                                $expr: { $eq: ['$_id', '$$stringValue'] },
                            },
                        },
                    ],
                    as: `${entityRel}Objects`,
                },
            },
        ];
    }
};
exports.GenericRepository = GenericRepository;
exports.GenericRepository = GenericRepository = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [mongoose_1.Model])
], GenericRepository);
