import { AbstractEntityLoader } from '../../loader/abstract-entity.loader';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { JWTPayload } from '@devseeder/nestjs-microservices-core';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { AbstractDocument } from '../../schema/abstract.schema';
import { Relation } from '../../interface/relation.interface';
import { GenericRepository } from '../../mongoose/generic.repository';
export declare class AbstractDBService<Collection, MongooseModel, ResponseModel> extends AbstractEntityLoader {
    protected readonly repository: GenericRepository<Collection>;
    protected readonly entity: string;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService?: GetTranslationService;
    protected readonly errorService?: ErrorService;
    protected readonly request?: Request;
    protected readonly scopeKey?: string;
    private memoryQueryService;
    constructor(repository: GenericRepository<Collection>, entity: string, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], translationService?: GetTranslationService, errorService?: ErrorService, request?: Request, scopeKey?: string);
    protected convertRelation(item: Partial<MongooseModel> | Partial<AbstractDocument>, validateInput?: boolean): Promise<ResponseModel>;
    private convertRelationItem;
    private validateOperatorFields;
    protected convertValueRelation(rel: Relation, value: string, validateInput?: boolean): Promise<any>;
    protected validateId(id: string): Promise<MongooseModel>;
    protected validateOnlyLoggedUser(item: Partial<MongooseModel>, localUserId: string): Promise<void>;
    protected validateOnlyLoggedUserForItems(items: Partial<MongooseModel>[]): Promise<void>;
    protected getLocalUserId(): Promise<string | null>;
    protected getDynamicValues(item: Partial<MongooseModel> | Partial<AbstractDocument>): Partial<MongooseModel> | Partial<AbstractDocument>;
    protected getFieldTranslation(key: string): Promise<string>;
    protected getLoggedUser(): JWTPayload;
}
