"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractDBService = void 0;
const get_dynamic_value_service_1 = require("../dynamic/get-dynamic-value.service");
const abstract_entity_loader_1 = require("../../loader/abstract-entity.loader");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const nestjs_microservices_core_1 = require("@devseeder/nestjs-microservices-core");
const error_keys_enum_1 = require("../../enum/error-keys.enum");
const generic_repository_1 = require("../../mongoose/generic.repository");
const MemoryQueryService_1 = require("../memory-query/MemoryQueryService");
let AbstractDBService = class AbstractDBService extends abstract_entity_loader_1.AbstractEntityLoader {
    constructor(repository, entity, fieldSchemaData = [], entitySchemaData = [], translationService, errorService, request, scopeKey) {
        super(entity, fieldSchemaData, entitySchemaData);
        this.repository = repository;
        this.entity = entity;
        this.fieldSchemaData = fieldSchemaData;
        this.entitySchemaData = entitySchemaData;
        this.translationService = translationService;
        this.errorService = errorService;
        this.request = request;
        this.scopeKey = scopeKey;
        this.memoryQueryService = new MemoryQueryService_1.MemoryQueryService();
    }
    convertRelation(item, validateInput = true) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            if (!item || !Object.keys(item).length)
                return null;
            const relations = this.fieldSchemaDb.filter((schema) => schema.type === 'externalId');
            const itemResponse = Object.assign({}, item);
            try {
                for (var _d = true, relations_1 = __asyncValues(relations), relations_1_1; relations_1_1 = yield relations_1.next(), _a = relations_1_1.done, !_a; _d = true) {
                    _c = relations_1_1.value;
                    _d = false;
                    const schema = _c;
                    yield this.convertRelationItem(schema, item, itemResponse, validateInput);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = relations_1.return)) yield _b.call(relations_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.getDynamicValues(itemResponse);
        });
    }
    convertRelationItem(schema, item, itemResponse, validateInput = true) {
        var _a, e_2, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const rel = {
                key: schema.key,
                service: schema.externalRelation.service,
                refKey: schema.externalRelation['refKey'] || undefined,
                repoKey: schema.externalRelation['repoKey'] || undefined,
                skipTranslate: schema.externalRelation['skipTranslate'] || false,
            };
            let keys = [''];
            if (schema.searchEgines &&
                schema.searchEgines.find((op) => Object.values(nestjs_microservices_schemas_1.VALIDATE_ID_ENUMS).includes(op))) {
                keys = ['', ...Object.values(nestjs_microservices_schemas_1.VALIDATE_ID_ENUMS)];
            }
            const value = item[rel.key];
            let isNormalValidation = true;
            try {
                for (var _d = true, keys_1 = __asyncValues(keys), keys_1_1; keys_1_1 = yield keys_1.next(), _a = keys_1_1.done, !_a; _d = true) {
                    _c = keys_1_1.value;
                    _d = false;
                    const key = _c;
                    const validationRes = yield this.validateOperatorFields(key.length ? `${rel.key}_${key}` : rel.key, item, itemResponse, rel, key, validateInput);
                    if (!validationRes)
                        isNormalValidation = false;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = keys_1.return)) yield _b.call(keys_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            if (!isNormalValidation || value === undefined)
                return;
            const valueRelation = yield this.convertValueRelation(rel, value, validateInput);
            itemResponse[rel.key] = Object.assign(Object.assign({ id: value }, valueRelation), { value: valueRelation['valueRelation'] });
        });
    }
    validateOperatorFields(key, item, itemResponse, relation, operator, validateInput = true) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = item[key];
            if (value === undefined)
                return true;
            if (!Array.isArray(value) && String(value).split(',').length > 1)
                value = value.split(',');
            if (Array.isArray(value) && value.length) {
                const relPromises = value.map((val) => __awaiter(this, void 0, void 0, function* () {
                    const valueRelation = yield this.convertValueRelation(relation, val, validateInput);
                    return Object.assign(Object.assign({ id: val }, valueRelation), { value: valueRelation['valueRelation'] });
                }));
                itemResponse[key] = yield Promise.all(relPromises);
                return false;
            }
            if (operator !== '' &&
                Object.values(nestjs_microservices_schemas_1.VALIDATE_ID_ENUMS).includes(operator)) {
                yield this.convertValueRelation(relation, value);
                return false;
            }
            return true;
        });
    }
    convertValueRelation(rel, value, validateInput = true) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!value || (Array.isArray(value) && !value.length))
                return null;
            const memoryResult = this.memoryQueryService.getMemory(this.entity, rel.refKey ? rel.refKey : '_id', value);
            let objValue;
            try {
                const serviceKey = `get${rel.service.capitalizeFirstLetter()}Service`;
                if (memoryResult)
                    objValue = memoryResult;
                else if (rel === null || rel === void 0 ? void 0 : rel.refKey) {
                    objValue = yield this[serviceKey].search({ [rel === null || rel === void 0 ? void 0 : rel.refKey]: value });
                }
                else
                    objValue = yield this[serviceKey].getById(value);
            }
            catch (err) {
                this.logger.error(`Error searching id: ${JSON.stringify(err)}`);
                this.logger.error(err);
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                    key: yield this.getFieldTranslation(rel.key),
                    value,
                });
            }
            if (!memoryResult)
                this.memoryQueryService.set(this.entity, rel.refKey ? rel.refKey : '_id', value, objValue);
            const objKey = rel.repoKey ? rel.repoKey : 'name';
            if (objValue === null || objValue === undefined) {
                if (!validateInput)
                    return value;
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                    key: yield this.getFieldTranslation(rel.key),
                    value,
                });
            }
            let valueRelation = objValue[objKey];
            let translated;
            if (objValue.translations && objValue.translations.length) {
                const lang = this.translationService.getLang();
                const translation = objValue.translations.filter((tra) => tra.locale == lang);
                valueRelation = translation[0].value;
                translated = valueRelation;
            }
            return Object.assign(Object.assign({}, objValue), { valueRelation, translated });
        });
    }
    validateId(id) {
        return __awaiter(this, void 0, void 0, function* () {
            let item;
            try {
                item = yield this.repository.findById(id);
            }
            catch (err) {
                const entityTranslation = yield this.translationService.getEntityTranslation(this.entitySchema.entity);
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.NOT_FOUND, {
                    key: entityTranslation.itemLabel,
                });
            }
            if (!item) {
                const entityTranslation = yield this.translationService.getEntityTranslation(this.entitySchema.entity);
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.NOT_FOUND, {
                    key: entityTranslation.itemLabel,
                });
            }
            yield this.validateOnlyLoggedUserForItems([item]);
            return item;
        });
    }
    validateOnlyLoggedUser(item, localUserId) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.entitySchema.userKey)
                return;
            const loggedUser = this.getLoggedUser();
            if (!item[this.entitySchema.userKey] ||
                !loggedUser ||
                !loggedUser.scopes ||
                !loggedUser.scopes.length ||
                !this['getUsersService'])
                return;
            if (loggedUser.scopes.includes(`${this.scopeKey}/ADM`))
                return;
            this.logger.log(`Validating Only Logged User...`);
            const requestScope = this.request['metaScopes'];
            this.logger.log(`RequestScope: ${JSON.stringify(requestScope)}`);
            const entityScopes = this.entitySchema.authScopes.filter((aut) => aut.accessKey === requestScope.accessKey);
            if (!entityScopes.length) {
                this.logger.warn(`No escope for entity ${this.entity} and accessKey ${requestScope.accessKey}`);
                return;
            }
            const onlyLogged = entityScopes[0].scopes.filter((scope) => loggedUser.scopes.includes(`${this.scopeKey}/${scope.key}`) &&
                scope.onlyLoggedUser);
            if (!onlyLogged.length)
                return;
            this.logger.log(`Auth User ${localUserId} == Entity User ${item[this.entitySchema.userKey]}`);
            if (localUserId !== item[this.entitySchema.userKey])
                yield this.errorService.throwError(error_keys_enum_1.ErrorKeys.OPERATE_OTHERS_USERS, {
                    key: this.entity,
                });
        });
    }
    validateOnlyLoggedUserForItems(items) {
        var _a, items_1, items_1_1;
        var _b, e_3, _c, _d;
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.entitySchema.userKey)
                return;
            const localUserId = yield this.getLocalUserId();
            if (!localUserId)
                return;
            try {
                for (_a = true, items_1 = __asyncValues(items); items_1_1 = yield items_1.next(), _b = items_1_1.done, !_b; _a = true) {
                    _d = items_1_1.value;
                    _a = false;
                    const item = _d;
                    yield this.validateOnlyLoggedUser(item, localUserId);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (!_a && !_b && (_c = items_1.return)) yield _c.call(items_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        });
    }
    getLocalUserId() {
        return __awaiter(this, void 0, void 0, function* () {
            const loggedUser = this.getLoggedUser();
            if (!loggedUser || !this['getUsersService'])
                return null;
            const userAuthId = loggedUser[this.entitySchema.userKey];
            this.logger.log(`Checking user for idUserAuth ${userAuthId}`);
            const userDB = yield this['getUsersService'].search({ idUserAuth: userAuthId, select: 'name,username' }, false, false);
            if (!userDB.items.length)
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                    key: 'Auth User',
                    value: userAuthId,
                });
            return userDB.items[0]._id.toString();
        });
    }
    getDynamicValues(item) {
        Object.keys(item)
            .filter((key) => typeof item[key] == 'string' &&
            (item[key].startsWith('@') || item[key].startsWith('$')))
            .forEach((key) => {
            item[key] = get_dynamic_value_service_1.DynamicValueService.getDynamicValue(item[key], item[key], item);
        });
        return item;
    }
    getFieldTranslation(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const fieldTranslation = yield this.translationService.getFieldTranslation(this.entityLabels, key);
            return fieldTranslation.fieldLabel;
        });
    }
    getLoggedUser() {
        const payload = nestjs_microservices_core_1.AuthenticatorExtractorHelper.extractBearerTokenAuth(this.request.headers['authorization'].replace('Bearer ', ''));
        return payload;
    }
};
exports.AbstractDBService = AbstractDBService;
exports.AbstractDBService = AbstractDBService = __decorate([
    __param(6, (0, common_1.Inject)(core_1.REQUEST)),
    __metadata("design:paramtypes", [generic_repository_1.GenericRepository, String, Array, Array, nestjs_microservices_schemas_1.GetTranslationService,
        nestjs_microservices_schemas_1.ErrorService,
        Request, String])
], AbstractDBService);
