import { AbstractDBService } from './abstract-db.service';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { GenericRepository } from '../../mongoose/generic.repository';
import { Search } from '../../dto';
export declare class AbstractSearchService<Collection, MongooseModel, ResponseModel, SearchParams extends Search> extends AbstractDBService<Collection, MongooseModel, ResponseModel> {
    protected readonly repository: GenericRepository<Collection>;
    protected readonly entity: string;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService?: GetTranslationService;
    protected readonly errorService?: ErrorService;
    protected readonly request?: Request;
    protected readonly scopeKey?: string;
    constructor(repository: GenericRepository<Collection>, entity: string, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], translationService?: GetTranslationService, errorService?: ErrorService, request?: Request, scopeKey?: string);
    protected buildSearchEgines(item: SearchParams): Promise<Partial<SearchParams>>;
    private validateIdsSearch;
    private buildSearchEgineItem;
    protected buildSearchParams(searchParams: SearchParams): Promise<Partial<SearchParams>>;
    protected buildSearchGroup(searchParams: SearchParams): Promise<Partial<SearchParams>>;
    protected validateOrderField(item: Partial<SearchParams>, orderBy?: any, orderMode?: number): {
        sort: object;
        sortExternal: object;
        hasExternal: boolean;
    };
    joinParentSearch(searchParams: SearchParams): Promise<SearchParams>;
    joinChildrenSearch(searchParams: SearchParams): Promise<SearchParams>;
    private validateSearchRelation;
    protected validateLoggedUserByCount(count: number, searchWhere: Partial<SearchParams>): Promise<void>;
}
