"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractSearchService = void 0;
const schema_validator_helper_1 = require("../../helper/validator/schema-validator.helper");
const field_schema_builder_1 = require("../../helper/validator/field-schema.builder");
const abstract_db_service_1 = require("./abstract-db.service");
const search_encapsulator_helper_1 = require("../../helper/search/search-encapsulator.helper");
const nestjs_microservices_schemas_1 = require("@devseeder/nestjs-microservices-schemas");
const core_1 = require("@nestjs/core");
const common_1 = require("@nestjs/common");
const nestjs_microservices_schemas_2 = require("@devseeder/nestjs-microservices-schemas");
const error_keys_enum_1 = require("../../enum/error-keys.enum");
const generic_repository_1 = require("../../mongoose/generic.repository");
let AbstractSearchService = class AbstractSearchService extends abstract_db_service_1.AbstractDBService {
    constructor(repository, entity, fieldSchemaData = [], entitySchemaData = [], translationService, errorService, request, scopeKey) {
        super(repository, entity, fieldSchemaData, entitySchemaData, translationService, errorService, request);
        this.repository = repository;
        this.entity = entity;
        this.fieldSchemaData = fieldSchemaData;
        this.entitySchemaData = entitySchemaData;
        this.translationService = translationService;
        this.errorService = errorService;
        this.request = request;
        this.scopeKey = scopeKey;
    }
    buildSearchEgines(item) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!item)
                return null;
            const itemResponse = Object.assign({}, item);
            const searchEngines = this.fieldSchemaDb.filter((schema) => schema.searchEgines && schema.searchEgines.length);
            for (const schema of searchEngines) {
                const value = item[schema.key];
                schema.searchEgines.forEach((eng) => {
                    this.buildSearchEgineItem(value, schema, eng, itemResponse);
                });
            }
            if (item['_ids']) {
                itemResponse['_id'] = yield this.validateIdsSearch(item['_ids']);
                delete itemResponse['_ids'];
            }
            return schema_validator_helper_1.SchemaValidator.removeUndefined(itemResponse);
        });
    }
    validateIdsSearch(idsValue) {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const ids = idsValue.split(',');
            try {
                for (var _d = true, ids_1 = __asyncValues(ids), ids_1_1; ids_1_1 = yield ids_1.next(), _a = ids_1_1.done, !_a; _d = true) {
                    _c = ids_1_1.value;
                    _d = false;
                    const id = _c;
                    let res;
                    try {
                        res = yield this.repository.find({ _id: ids }, { name: 1 });
                    }
                    catch (err) {
                        this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                            key: 'Id',
                            value: id,
                        });
                    }
                    if (!res.length)
                        this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                            key: 'Id',
                            value: id,
                        });
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = ids_1.return)) yield _b.call(ids_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return {
                $in: ids,
            };
        });
    }
    buildSearchEgineItem(value, schema, operator, itemResponse) {
        if (field_schema_builder_1.FieldSchemaBuilder.checkUndefinedValue(value, schema, itemResponse, operator))
            return;
        switch (operator) {
            case nestjs_microservices_schemas_2.SearchEgineOperators.LIKE:
                itemResponse[schema.key] = {
                    $regex: new RegExp(`${itemResponse[`${schema.key}_like`]}`),
                    $options: 'i',
                };
                delete itemResponse[`${schema.key}_like`];
                break;
            case nestjs_microservices_schemas_2.SearchEgineOperators.IN:
                itemResponse[schema.key] = {
                    $in: value.split(','),
                };
                break;
            case nestjs_microservices_schemas_2.SearchEgineOperators.NOT_IN:
                itemResponse[schema.key] = {
                    $nin: itemResponse[`${schema.key}_nin`].split(','),
                };
                delete itemResponse[`${schema.key}_nin`];
                break;
            case nestjs_microservices_schemas_2.SearchEgineOperators.BETWEEN:
                const betweenQuery = {};
                if (itemResponse[`${schema.key}_start`])
                    betweenQuery['$gte'] = itemResponse[`${schema.key}_start`];
                if (itemResponse[`${schema.key}_end`])
                    betweenQuery['$lte'] = itemResponse[`${schema.key}_end`];
                if (Object.keys(betweenQuery).length)
                    itemResponse[schema.key] = betweenQuery;
                delete itemResponse[`${schema.key}_start`];
                delete itemResponse[`${schema.key}_end`];
                break;
            default:
                const operatorQuery = {};
                if (itemResponse[`${schema.key}_${operator}`])
                    operatorQuery[`$${operator}`] =
                        itemResponse[`${schema.key}_${operator}`];
                if (Object.keys(operatorQuery).length)
                    itemResponse[schema.key] = operatorQuery;
                delete itemResponse[`${schema.key}_${operator}`];
                break;
        }
    }
    buildSearchParams(searchParams) {
        var _a, e_2, _b, _c, _d, e_3, _e, _f;
        return __awaiter(this, void 0, void 0, function* () {
            const encapObjects = search_encapsulator_helper_1.SearchEncapsulatorHelper.buildEncapsulatedSearch(this.getDynamicValues(searchParams));
            const andParams = [];
            try {
                for (var _g = true, _h = __asyncValues(encapObjects['$and']), _j; _j = yield _h.next(), _a = _j.done, !_a; _g = true) {
                    _c = _j.value;
                    _g = false;
                    const clauseGroup = _c;
                    const group = yield this.buildSearchGroup(clauseGroup);
                    if (!group)
                        continue;
                    andParams.push(group);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_g && !_a && (_b = _h.return)) yield _b.call(_h);
                }
                finally { if (e_2) throw e_2.error; }
            }
            const orParams = [];
            try {
                for (var _k = true, _l = __asyncValues(encapObjects['$or']), _m; _m = yield _l.next(), _d = _m.done, !_d; _k = true) {
                    _f = _m.value;
                    _k = false;
                    const clauseGroup = _f;
                    const group = yield this.buildSearchGroup(clauseGroup);
                    if (!group)
                        continue;
                    orParams.push(group);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (!_k && !_d && (_e = _l.return)) yield _e.call(_l);
                }
                finally { if (e_3) throw e_3.error; }
            }
            const params = yield this.buildSearchGroup(Object.assign(Object.assign({}, encapObjects), { $and: undefined, $or: undefined }));
            if (andParams.length)
                params['$and'] = andParams;
            if (orParams.length)
                params['$or'] = orParams;
            return Object.assign(Object.assign({}, params), { active: params && params.active !== undefined ? params.active : true });
        });
    }
    buildSearchGroup(searchParams) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.convertRelation(searchParams);
            const searchEngs = yield this.buildSearchEgines(searchParams);
            yield this.joinParentSearch(searchEngs);
            yield this.joinChildrenSearch(searchEngs);
            return searchEngs;
        });
    }
    validateOrderField(item, orderBy = null, orderMode = 1) {
        if (!orderBy)
            return { sort: {}, sortExternal: {}, hasExternal: false };
        const sortObj = {};
        const sortExternal = {};
        let hasExternal = false;
        const orderKeys = orderBy.split(',');
        orderKeys.forEach((key) => {
            const isFieldOrder = this.fieldSchemaDb.filter((field) => field.key === key.trim() && field.orderBy);
            if (!isFieldOrder.length)
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                    key: 'order field',
                    value: key.trim(),
                });
            if (isFieldOrder[0].type === 'externalId') {
                hasExternal = true;
                sortExternal[key.trim()] = orderMode;
                return;
            }
            sortObj[key.trim()] = orderMode;
            sortExternal[key.trim()] = orderMode;
        });
        delete item['orderBy'];
        delete item['orderMode'];
        this.logger.log(`Sorting ${JSON.stringify(sortObj)}...`);
        return { sort: sortObj, sortExternal, hasExternal };
    }
    joinParentSearch(searchParams) {
        var _a, e_4, _b, _c, _d, e_5, _e, _f;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                for (var _g = true, _h = __asyncValues(this.fieldSchemaDb.filter((field) => field.externalRelation)), _j; _j = yield _h.next(), _a = _j.done, !_a; _g = true) {
                    _c = _j.value;
                    _g = false;
                    const field = _c;
                    const relation = field.externalRelation.service;
                    const keys = Object.keys(searchParams).filter((key) => key.startsWith(`$parent.${relation}`));
                    if (!keys.length)
                        continue;
                    const relationWhere = {};
                    try {
                        for (var _k = true, keys_1 = (e_5 = void 0, __asyncValues(keys)), keys_1_1; keys_1_1 = yield keys_1.next(), _d = keys_1_1.done, !_d; _k = true) {
                            _f = keys_1_1.value;
                            _k = false;
                            const key = _f;
                            const splitKey = key.split('.');
                            this.logger.log(`Relation: ${splitKey[1]} && Key: ${splitKey[2]}`);
                            relationWhere[splitKey[2]] = searchParams[key];
                            delete searchParams[key];
                        }
                    }
                    catch (e_5_1) { e_5 = { error: e_5_1 }; }
                    finally {
                        try {
                            if (!_k && !_d && (_e = keys_1.return)) yield _e.call(keys_1);
                        }
                        finally { if (e_5) throw e_5.error; }
                    }
                    const parentItems = yield this[`get${relation.capitalizeFirstLetter()}Service`].search(Object.assign(Object.assign({}, relationWhere), { select: 'name' }), false, false);
                    searchParams[field.key] = {
                        $in: parentItems.items.map((item) => item._id),
                    };
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (!_g && !_a && (_b = _h.return)) yield _b.call(_h);
                }
                finally { if (e_4) throw e_4.error; }
            }
            this.validateSearchRelation(searchParams, 'parent');
            return searchParams;
        });
    }
    joinChildrenSearch(searchParams) {
        var _a, e_6, _b, _c, _d, e_7, _e, _f;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                for (var _g = true, _h = __asyncValues(this.entitySchema.subRelations), _j; _j = yield _h.next(), _a = _j.done, !_a; _g = true) {
                    _c = _j.value;
                    _g = false;
                    const sub = _c;
                    const relation = sub.service;
                    const keys = Object.keys(searchParams).filter((key) => key.startsWith(`$children.${relation}`));
                    if (!keys.length)
                        continue;
                    const relationWhere = {};
                    try {
                        for (var _k = true, keys_2 = (e_7 = void 0, __asyncValues(keys)), keys_2_1; keys_2_1 = yield keys_2.next(), _d = keys_2_1.done, !_d; _k = true) {
                            _f = keys_2_1.value;
                            _k = false;
                            const key = _f;
                            const splitKey = key.split('.');
                            this.logger.log(`Relation: ${splitKey[1]} && Key: ${splitKey[2]}`);
                            relationWhere[splitKey[2]] = searchParams[key];
                            delete searchParams[key];
                        }
                    }
                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                    finally {
                        try {
                            if (!_k && !_d && (_e = keys_2.return)) yield _e.call(keys_2);
                        }
                        finally { if (e_7) throw e_7.error; }
                    }
                    this.logger.log(`get${relation.capitalizeFirstLetter()}Service`);
                    const parentItems = yield this[`get${relation.capitalizeFirstLetter()}Service`].search(Object.assign(Object.assign({}, relationWhere), { select: 'name' }), false, false);
                    this.logger.log(`Itens: ${JSON.stringify(parentItems.items)}`);
                    if (!parentItems.items.length)
                        this.errorService.throwError(error_keys_enum_1.ErrorKeys.NOT_FOUND);
                    const relatedIds = parentItems.items.map((item) => item._id).join(',');
                    searchParams['_ids'] = searchParams['_ids']
                        ? `${searchParams['_ids']},${relatedIds}`
                        : relatedIds;
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (!_g && !_a && (_b = _h.return)) yield _b.call(_h);
                }
                finally { if (e_6) throw e_6.error; }
            }
            this.validateSearchRelation(searchParams, 'children');
            return searchParams;
        });
    }
    validateSearchRelation(searchParams, familyKey) {
        const pattern = `^\$${familyKey}\.\w+\.\w+$`;
        const regexFamily = new RegExp(pattern);
        Object.keys(searchParams).forEach((key) => {
            if (regexFamily.test(key))
                this.errorService.throwError(error_keys_enum_1.ErrorKeys.INVALID_DATA, {
                    key: 'Relation',
                    value: key.split('.')[1],
                });
        });
    }
    validateLoggedUserByCount(count, searchWhere) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.entitySchema.userKey)
                return;
            const itemsUser = yield this.repository.count(Object.assign(Object.assign({}, searchWhere), { [this.entitySchema.userKey]: yield this.getLocalUserId() }));
            if (itemsUser !== count)
                yield this.errorService.throwError(error_keys_enum_1.ErrorKeys.OPERATE_OTHERS_USERS, {
                    key: this.entity,
                });
        });
    }
};
exports.AbstractSearchService = AbstractSearchService;
exports.AbstractSearchService = AbstractSearchService = __decorate([
    __param(6, (0, common_1.Inject)(core_1.REQUEST)),
    __metadata("design:paramtypes", [generic_repository_1.GenericRepository, String, Array, Array, nestjs_microservices_schemas_1.GetTranslationService,
        nestjs_microservices_schemas_1.ErrorService,
        Request, String])
], AbstractSearchService);
