/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/aggregate" />
/// <reference types="mongoose/types/callback" />
/// <reference types="mongoose/types/collection" />
/// <reference types="mongoose/types/connection" />
/// <reference types="mongoose/types/cursor" />
/// <reference types="mongoose/types/document" />
/// <reference types="mongoose/types/error" />
/// <reference types="mongoose/types/expressions" />
/// <reference types="mongoose/types/helpers" />
/// <reference types="mongoose/types/middlewares" />
/// <reference types="mongoose/types/indexes" />
/// <reference types="mongoose/types/models" />
/// <reference types="mongoose/types/mongooseoptions" />
/// <reference types="mongoose/types/pipelinestage" />
/// <reference types="mongoose/types/populate" />
/// <reference types="mongoose/types/query" />
/// <reference types="mongoose/types/schemaoptions" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/types" />
/// <reference types="mongoose/types/utility" />
/// <reference types="mongoose/types/validation" />
/// <reference types="mongoose/types/virtuals" />
/// <reference types="mongoose/types/inferschematype" />
import { AbstractDBService } from './abstract-db.service';
import { ClientSession, ObjectId } from 'mongoose';
import { CloneManyResponse, CloneOneResponse } from '../../dto/response/clone.response';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { GenericRepository } from '../../mongoose/generic.repository';
export declare class GenericCreateService<Collection, ResponseModel, BodyDto> extends AbstractDBService<Collection, Collection & Document, ResponseModel> {
    protected readonly repository: GenericRepository<Collection>;
    protected readonly entity: string;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService?: GetTranslationService;
    protected readonly errorService?: ErrorService;
    protected readonly request?: Request;
    protected readonly scopeKey?: string;
    constructor(repository: GenericRepository<Collection>, entity: string, fieldSchemaData: FieldSchema[], entitySchemaData: EntitySchema[], translationService?: GetTranslationService, errorService?: ErrorService, request?: Request, scopeKey?: string);
    create(body: BodyDto, validateInput?: boolean, session?: ClientSession): Promise<{
        _id: ObjectId;
    }>;
    cloneOne(id: string, changeUniqueIndex?: boolean, relationsToClone?: any[], cloneBody?: {}, session?: ClientSession, validateInput?: boolean): Promise<CloneOneResponse>;
    cloneByIds(ids: string[], relationsToClone?: any[], cloneBody?: {}): Promise<CloneManyResponse>;
    private cloneRelations;
    private getUniqueIndexToClone;
}
