import { CountResponse, PaginatedResponse } from '../../dto/response/paginated.response';
import { GroupByResponse } from '../../dto/response/groupby/group-by.response';
import { AbstractSearchService } from './abstract-search.service';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { Search } from '../../dto';
import { FormSchemaResponse } from '../../interface/field-schema.interface';
import { GenericRepository } from '../../mongoose/generic.repository';
export declare class GenericGetService<Collection, ResponseModel, SearchParams extends Search> extends AbstractSearchService<Collection, Collection & Document, ResponseModel, Search> {
    protected readonly repository: GenericRepository<Collection>;
    protected readonly entity: string;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService?: GetTranslationService;
    protected readonly errorService?: ErrorService;
    protected readonly request?: Request;
    protected readonly scopeKey?: string;
    constructor(repository: GenericRepository<Collection>, entity: string, fieldSchemaData?: FieldSchema[], entitySchemaData?: EntitySchema[], translationService?: GetTranslationService, errorService?: ErrorService, request?: Request, scopeKey?: string);
    search(searchParams?: SearchParams, paginate?: boolean, convertOutput?: boolean): Promise<PaginatedResponse<ResponseModel>>;
    getById(id: string, validateError?: boolean): Promise<ResponseModel>;
    getForm(): Promise<FormSchemaResponse>;
    private getPagination;
    private getSelectFields;
    private getPaginatedResponse;
    count(searchParams: SearchParams): Promise<CountResponse>;
    groupBy(groupedEntity: string, searchParams?: SearchParams): Promise<GroupByResponse[]>;
}
