/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/aggregate" />
/// <reference types="mongoose/types/callback" />
/// <reference types="mongoose/types/collection" />
/// <reference types="mongoose/types/connection" />
/// <reference types="mongoose/types/cursor" />
/// <reference types="mongoose/types/document" />
/// <reference types="mongoose/types/error" />
/// <reference types="mongoose/types/expressions" />
/// <reference types="mongoose/types/helpers" />
/// <reference types="mongoose/types/middlewares" />
/// <reference types="mongoose/types/indexes" />
/// <reference types="mongoose/types/models" />
/// <reference types="mongoose/types/mongooseoptions" />
/// <reference types="mongoose/types/pipelinestage" />
/// <reference types="mongoose/types/populate" />
/// <reference types="mongoose/types/query" />
/// <reference types="mongoose/types/schemaoptions" />
/// <reference types="mongoose/types/schematypes" />
/// <reference types="mongoose/types/session" />
/// <reference types="mongoose/types/types" />
/// <reference types="mongoose/types/utility" />
/// <reference types="mongoose/types/validation" />
/// <reference types="mongoose/types/virtuals" />
/// <reference types="mongoose/types/inferschematype" />
import { AbstractBodyDto } from '../../dto/body/abtract-body.dto';
import { AbstractSearchService } from './abstract-search.service';
import { ErrorService, GetTranslationService } from '@devseeder/nestjs-microservices-schemas';
import { ClientSession } from 'mongoose';
import { Reflector } from '@nestjs/core';
import { EntitySchema, FieldSchema } from '@devseeder/nestjs-microservices-schemas';
import { AbstractSchema } from '../../schema/abstract.schema';
import { InactivationReason } from '../../enum/inactivation-reason.enum';
import { GenericRepository } from '../../mongoose/generic.repository';
export declare class GenericUpdateService<Collection, ResponseModel, BodyDto extends AbstractBodyDto, SearchParams> extends AbstractSearchService<Collection, Collection & Document, ResponseModel, SearchParams> {
    protected readonly repository: GenericRepository<Collection>;
    protected readonly entity: string;
    protected readonly fieldSchemaData: FieldSchema[];
    protected readonly entitySchemaData: EntitySchema[];
    protected readonly translationService?: GetTranslationService;
    protected readonly errorService?: ErrorService;
    protected readonly request?: Request;
    protected readonly reflector?: Reflector;
    protected readonly scopeKey?: string;
    constructor(repository: GenericRepository<Collection>, entity: string, fieldSchemaData: FieldSchema[], entitySchemaData: EntitySchema[], translationService?: GetTranslationService, errorService?: ErrorService, request?: Request, reflector?: Reflector, scopeKey?: string);
    updateById(id: string, body: Partial<BodyDto> | Partial<AbstractSchema>, session?: ClientSession): Promise<void>;
    activation(id: string, activation: boolean, cascadeRelations?: string, reason?: InactivationReason): Promise<void>;
    cascadeUpdate(id: string, body: Partial<AbstractSchema>, active: boolean, cascadeRelations?: string, session?: ClientSession): Promise<void>;
    updateBy(search: SearchParams, body: Partial<BodyDto> | Partial<AbstractSchema>): Promise<void>;
}
